mod io_vec;

pub use io_vec::IOBuffer;

use super::{CPUResult, ExecErr, CPU};

use super::registers::{Register, Word};

/// This trait represents all environments where our CPU can operate.
/// What this means is roughly defining system calls.

pub trait Sys: Sized {
    // r should actually be 4 bits, while c should be
    // 8 bits. TODO: more efficient packing?
    /// Performs system call.
    fn call(cpu: &mut CPU<Self>, r: Register, c: Word) -> CPUResult<()>;
}
