#[cfg(test)]
mod tests {

    use crate::{
        cpu::{IOBuffer, CPU},
        loader::unloader::make_string,
    };

    #[test]
    fn hello_world_binary_test() {
        let hw = String::from("Hello world!");

        let mut k = make_string(&hw);

        let mut code: Vec<u16> = vec![
            0b0111000100000011, // addi ra 3
            0b1110000100000011, // ecall ra 3
            0b1111000000000000, // HALT.
        ];

        code.append(&mut k);

        let mut env = IOBuffer::default();

        let mut cpu = CPU::new(&mut env);

        for c in &code[..] {
            println!("{:#018b}", c);
        }

        cpu.run_code_raw(&code);

        assert_eq!(hw, cpu.env.output);
    }
}
