mod display;
pub mod loader;
pub mod unloader;

mod constants;

mod tests;

/// Represents a section, or symbol, that must end up in the
/// binary file.
#[derive(Debug)]
pub struct Section {
    /// Name of the symbol/section
    name: String,
    /// Content in bytes
    content: Vec<u16>,
}

impl Section {
    pub fn new(name: String, content: &[u16]) -> Section {
        Section { name, content: content.to_owned() }
    }
}
