#[cfg(test)]
mod tests {
    use crate::loader::Section;

    use super::super::loader::*;
    use super::super::unloader::*;

    // fuzzable, TODO
    fn write_read_str_identity(s: &str) {
        let bytes = make_string(s);

        // pop null-terminator;
        // bytes.pop().expect("String doesn't even have a single byte?");
        // println!("w-r s: {:?}, b: {:?}", s, bytes);
        let (s0, _) = find_and_read_string(&bytes).unwrap();
        assert_eq!(s, &s0);
    }

    fn read_write_str_identity(b: Vec<u16>) {
        let (string, _) = find_and_read_string(&b).unwrap();
        let n_term = b.clone();
        // n_term.push(0);
        // println!("r-w s: {:?}, b: {:?}", string, n_term);
        assert_eq!(n_term, make_string(&string));
    }

    #[test]
    fn label_parse_identity() {
        let testwords = vec!["Hello,", "main", "è", "Hello,,", "v", "main", "pi"]; // should support utf-8
                                                                                   //
        for word in testwords {
            println!("\nTEST {}\n", word);

            write_read_str_identity(word);
            let bytes = make_string(word);
            // bytes.pop();
            println!(
                "word: {:?}, bytes: {:?}, length: {:?}",
                word,
                bytes,
                bytes.len()
            );
            read_write_str_identity(bytes);
            println!("Done with {:?}", word);
        }
    }

    // Symbol table test

    #[test]
    fn sy_test() {
        let fake_symbol_table: Vec<Section> = vec![
            Section::new("v".to_owned(), &[1, 2, 3]),
            Section::new("pi".to_owned(), &[3]),
            Section::new("main".to_owned(), &[231, 323, 433]), // Section { name: todo!(), content: todo!() },
                                                               // Section { name: todo!(), content: todo!() }
        ];

        let bin = make_binary(&fake_symbol_table);
        println!("{:?}", bin);

        let parsed_symbol_table = read_binary(&bin).expect("Wtf! We got error!");
        println!("{:?}", parsed_symbol_table);
    }
}
