
mod asm;
mod bin;

use asm::*;
use bin::*;

use crate::loader::loader::read_binary;

// We'll use the Cli to dictate which format kinds are available.
use super::cli::FormatKind;


use super::assembler::parser::{*};


pub enum CodeWrapper {
    Bin(Vec<u16>),
    Asm(Vec<Section>)
}



pub fn format_code(c: CodeWrapper, k: FormatKind) -> Result<String, crate::loader::loader::ParseError> {


    match k {
        FormatKind::FancyTable => match c {
            CodeWrapper::Bin(_) => todo!(),
            CodeWrapper::Asm(sections) => {
                return Ok(to_table(sections))},
        },
        FormatKind::Raw => match c {
            CodeWrapper::Bin(_) => todo!(),
            CodeWrapper::Asm(_) => todo!(),
        },
        FormatKind::BinSections => match c {
            CodeWrapper::Bin(_) => todo!(),
            CodeWrapper::Asm(_) => todo!(),
        },
        FormatKind::Serializable => match c {
            CodeWrapper::Bin(_) => todo!(),
            CodeWrapper::Asm(_) => todo!(),
        },
    }
    

}

